Overview | Package | Class | Use | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.basex.util
Class Array

    java.lang.Object
      org.basex.util.Array

    public final class Array

extends java.lang.Object

This class provides convenience methods for handling arrays.

Author:
  Workgroup DBIS, University of Konstanz 2005-07, ISC License, Christian Gruen

Field Summary
`static int[]` | `NOINTS` Empty integer array.

Method Summary
`static byte[][]` | `add(byte[][] ar, byte[] e)` Resizes an array and adds an entry at the end.
`static
`<T> T[]`
` | `add(T[] ar, T e)` Resizes an array and adds an entry at the end.
`static int` | `byteToInt(byte[] b)` Convert byte[4] to int.
`static int` | `byteToIntNN(byte[] b)` Convert byte[4] to int with a range from 0 to 2^32.
`static int` | `compareIntArrayEntry(int data1ID, int data1Pos, int data2ID, int data2Pos)` Compares 2 int[1][2] array entries and returns
`static boolean` | `contains(int i, int[] a)` Checks whether i is contained in a.
`static void` | `copy(byte[] src, byte[] trg, int s)` Copies the source token into the target token.
`static void` | `copy(java.lang.Object[] src, java.lang.Object[] trg, int s)` Copies the source array into the target array, starting from the specified offset.
`static byte[]` | `create(byte[] src, int pos, int len)` Creates a new array from the source array and with the specified length.
`static boolean[]` | `extend(boolean[] ar)` Doubles the array size.
`static byte[]` | `extend(byte[] ar)` Doubles the array size.
`static byte[][]` | `extend(byte[][] ar)` Doubles the array size.
`static char[]` | `extend(char[] ar)` Doubles the array size.
`static int[]` | `extend(int[] ar)` Doubles the array size.
`static int[][]` | `extend(int[][] ar)` Doubles the array size.
`static long[]` | `extend(long[] ar)` Doubles the array size.
`static java.lang.String[]` | `extend(java.lang.String[] ar)` Doubles the array size.
`static
`<T> T[]`
` | `extend(T[] ar)` Doubles the array size.
`static int[]` | `extractIDsFromData(int[][] data)` Extracts ids out of an int[2][]-array.
`static boolean[]` | `finish(boolean[] ar, int size)` Optimizes the array size.
`static byte[][]` | `finish(byte[][] ar, int size)` Optimizes the array size.
`static byte[]` | `finish(byte[] ar, int size)` Optimizes the array size.
`static int[]` | `finish(int[] ar, int size)` Optimizes the array size.
`static java.lang.String[]` | `finish(java.lang.String[] ar, int size)` Optimizes the array size.
`static
`<T> T[]`
` | `finish(T[] ar, int size)` Optimizes the array size.
`static void` | `move(java.lang.Object ar, int pos, int off, int l)` Moves entries inside an array.
`static boolean[]` | `resize(boolean[] ar, int os, int ns)` Convenience method for resizing a boolean array.
`static byte[][]` | `resize(byte[][] ar, int os, int ns)` Convenience method for resizing a two-dimensional byte array.
`static byte[]` | `resize(byte[] ar, int os, int ns)` Convenience method for resizing a byte array.
`static char[]` | `resize(char[] ar, int os, int ns)` Convenience method for resizing a character array.
`static int[][]` | `resize(int[][] ar, int os, int ns)` Convenience method for resizing an integer array.
`static int[]` | `resize(int[] ar, int os, int ns)` Convenience method for resizing an integer array.
`static long[]` | `resize(long[] ar, int os, int ns)` Convenience method for resizing an integer array.
`static java.lang.String[]` | `resize(java.lang.String[] ar, int os, int ns)` Convenience method for resizing a String array.
`static
`<T> T[]`
` | `resize(T[] ar, int os, int ns)` Doubles the array size.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### NOINTS

    public static final int[] NOINTS

  Empty integer array.

Method Detail

### add

    public static byte[][] add(byte[][] ar,
                               byte[] e)

  Resizes an array and adds an entry at the end.

  Parameters:
    `ar` - array to be resized
    `e` - entry to be added
  Returns:
    finished array

### add

    public static <T> T[] add(T[] ar,
                              T e)

  Resizes an array and adds an entry at the end.

  Type Parameters:
    `T` - array type
  Parameters:
    `ar` - array to be resized
    `e` - entry to be added
  Returns:
    array

### byteToInt

    public static int byteToInt(byte[] b)

  Convert byte[4] to int.

  Parameters:
    `b` - byte[]
  Returns:
    int value

### byteToIntNN

    public static int byteToIntNN(byte[] b)

  Convert byte[4] to int with a range from 0 to 2^32.

  Parameters:
    `b` - byte[]
  Returns:
    int value

### compareIntArrayEntry

    public static int compareIntArrayEntry(int data1ID,
                                           int data1Pos,
                                           int data2ID,
                                           int data2Pos)

  Compares 2 int[1][2] array entries and returns. * 0 for equality * -1 if intArrayEntry1 < intArrayEntry2 (same id) or * 1 if intArrayEntry1 > intArrayEntry2 (same id) * 2 real bigger (different id) * -2 real smaller (different id)

  Parameters:
    `data1ID` - int
    `data1Pos` - int
    `data2ID` - int
    `data2Pos` - int
  Returns:
    int result [0|-1|1|2|-2]

### contains

    public static boolean contains(int i,
                                   int[] a)

  Checks whether i is contained in a.

  Parameters:
    `i` - value to be found
    `a` - array to be checked
  Returns:
    boolean contained

### copy

    public static void copy(byte[] src,
                            byte[] trg,
                            int s)

  Copies the source token into the target token.

  Parameters:
    `src` - source array
    `trg` - target array
    `s` - start position

### copy

    public static void copy(java.lang.Object[] src,
                            java.lang.Object[] trg,
                            int s)

  Copies the source array into the target array, starting from the specified offset.

  Parameters:
    `src` - source array
    `trg` - target array
    `s` - start position

### create

    public static byte[] create(byte[] src,
                                int pos,
                                int len)

  Creates a new array from the source array and with the specified length.

  Parameters:
    `src` - source array
    `pos` - array position
    `len` - array length
  Returns:
    new array

### extend

    public static boolean[] extend(boolean[] ar)

  Doubles the array size.

  Parameters:
    `ar` - array to be resized
  Returns:
    finished array

### extend

    public static byte[] extend(byte[] ar)

  Doubles the array size.

  Parameters:
    `ar` - array to be resized
  Returns:
    finished array

### extend

    public static byte[][] extend(byte[][] ar)

  Doubles the array size.

  Parameters:
    `ar` - array to be resized
  Returns:
    finished array

### extend

    public static char[] extend(char[] ar)

  Doubles the array size.

  Parameters:
    `ar` - array to be resized
  Returns:
    finished array

### extend

    public static int[] extend(int[] ar)

  Doubles the array size.

  Parameters:
    `ar` - array to be resized
  Returns:
    finished array

### extend

    public static int[][] extend(int[][] ar)

  Doubles the array size.

  Parameters:
    `ar` - array to be resized
  Returns:
    finished array

### extend

    public static long[] extend(long[] ar)

  Doubles the array size.

  Parameters:
    `ar` - array to be resized
  Returns:
    finished array

### extend

    public static java.lang.String[] extend(java.lang.String[] ar)

  Doubles the array size.

  Parameters:
    `ar` - array to be resized
  Returns:
    finished array

### extend

    public static <T> T[] extend(T[] ar)

  Doubles the array size.

  Type Parameters:
    `T` - array type
  Parameters:
    `ar` - array to be resized
  Returns:
    array

### extractIDsFromData

    public static int[] extractIDsFromData(int[][] data)

  Extracts ids out of an int[2][]-array. int[0] = ids int[1] = position values

  Parameters:
    `data` - data
  Returns:
    ids int[]

### finish

    public static boolean[] finish(boolean[] ar,
                                   int size)

  Optimizes the array size.

  Parameters:
    `ar` - array to be resized
    `size` - final size
  Returns:
    finished array

### finish

    public static byte[][] finish(byte[][] ar,
                                  int size)

  Optimizes the array size.

  Parameters:
    `ar` - array to be resized
    `size` - final size
  Returns:
    finished array

### finish

    public static byte[] finish(byte[] ar,
                                int size)

  Optimizes the array size.

  Parameters:
    `ar` - array to be resized
    `size` - final size
  Returns:
    finished array

### finish

    public static int[] finish(int[] ar,
                               int size)

  Optimizes the array size.

  Parameters:
    `ar` - array to be resized
    `size` - final size
  Returns:
    finished array

### finish

    public static java.lang.String[] finish(java.lang.String[] ar,
                                            int size)

  Optimizes the array size.

  Parameters:
    `ar` - array to be resized
    `size` - final size
  Returns:
    finished array

### finish

    public static <T> T[] finish(T[] ar,
                                 int size)

  Optimizes the array size.

  Type Parameters:
    `T` - array type
  Parameters:
    `ar` - array to be resized
    `size` - final size
  Returns:
    array

### move

    public static void move(java.lang.Object ar,
                            int pos,
                            int off,
                            int l)

  Moves entries inside an array.

  Parameters:
    `ar` - array
    `pos` - position
    `off` - move offset
    `l` - length

### resize

    public static boolean[] resize(boolean[] ar,
                                   int os,
                                   int ns)

  Convenience method for resizing a boolean array.

  Parameters:
    `ar` - array to be resized
    `os` - old size
    `ns` - new size
  Returns:
    resized array

### resize

    public static byte[][] resize(byte[][] ar,
                                  int os,
                                  int ns)

  Convenience method for resizing a two-dimensional byte array.

  Parameters:
    `ar` - array to be resized
    `os` - old size
    `ns` - new size
  Returns:
    resized array

### resize

    public static byte[] resize(byte[] ar,
                                int os,
                                int ns)

  Convenience method for resizing a byte array.

  Parameters:
    `ar` - array to be resized
    `os` - old size
    `ns` - new size
  Returns:
    resized array

### resize

    public static char[] resize(char[] ar,
                                int os,
                                int ns)

  Convenience method for resizing a character array.

  Parameters:
    `ar` - array to be resized
    `os` - old size
    `ns` - new size
  Returns:
    resized array

### resize

    public static int[][] resize(int[][] ar,
                                 int os,
                                 int ns)

  Convenience method for resizing an integer array.

  Parameters:
    `ar` - array to be resized
    `os` - old size
    `ns` - new size
  Returns:
    resized array

### resize

    public static int[] resize(int[] ar,
                               int os,
                               int ns)

  Convenience method for resizing an integer array.

  Parameters:
    `ar` - array to be resized
    `os` - old size
    `ns` - new size
  Returns:
    resized array

### resize

    public static long[] resize(long[] ar,
                                int os,
                                int ns)

  Convenience method for resizing an integer array.

  Parameters:
    `ar` - array to be resized
    `os` - old size
    `ns` - new size
  Returns:
    resized array

### resize

    public static java.lang.String[] resize(java.lang.String[] ar,
                                            int os,
                                            int ns)

  Convenience method for resizing a String array.

  Parameters:
    `ar` - array to be resized
    `os` - old size
    `ns` - new size
  Returns:
    resized array

### resize

    public static <T> T[] resize(T[] ar,
                                 int os,
                                 int ns)

  Doubles the array size.

  Type Parameters:
    `T` - array type
  Parameters:
    `ar` - array to be resized
    `os` - old size
    `ns` - new size
  Returns:
    array

Overview | Package | Class | Use | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD